package com.tellhow.czp.app.jx.impl;

package ..deTemp.1745763027094;

import com.tellhow.czp.ExampleBuilder;
import com.tellhow.czp.app.impl.CZPImplDefault;
import com.tellhow.czp.app.jx.tools.SafeCheckUtil;
import com.tellhow.czp.app.jx.view.TempTicketJX;
import com.tellhow.czp.app.service.CZPService;
import com.tellhow.czp.datebase.QueryDeviceDao;
import com.tellhow.czp.user.User;
import com.tellhow.czp.user.UserDao;
import com.tellhow.graphicframework.basic.SVGFile;
import com.tellhow.graphicframework.constants.SystemConstants;
import com.tellhow.graphicframework.svg.document.SVGDocumentResolver;
import com.tellhow.graphicframework.utils.StringUtils;
import czprule.model.PowerDevice;
import czprule.rule.model.CardWordMode;
import czprule.rule.model.RuleBaseMode;
import czprule.rule.operationclass.RuleExeUtil;
import czprule.system.CBSystemConstants;
import czprule.system.DBManager;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import org.apache.log4j.Logger;
import org.dom4j.Element;
import org.springframework.util.CollectionUtils;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

public class CZPImplCheck extends CZPImplDefault {
  private Logger log = Logger.getLogger(getClass());
  
  public void setArg(String str) {
    CBSystemConstants.setImportInfo("");
    CBSystemConstants.jxpID = "";
    CBSystemConstants.ddpID = "";
    CBSystemConstants.ddzlID = "";
    str = str.toLowerCase();
    if (str.indexOf("=") >= 0) {
      if (str.startsWith("tellhowczp://")) {
        String info = str.replace("tellhowczp://", "").replace("/", "").replace("\\", "");
        Map<String, String> map = getUrlParams(info);
        if (map.containsKey("username")) {
          String username = "";
          try {
            username = URLDecoder.decode(map.get("username"), "UTF-8");
          } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
          } 
          String role = "0";
          if (map.containsKey("role")) {
            role = map.get("role");
            CBSystemConstants.roleCode = role;
          } 
          UserDao userdao = new UserDao();
          User user = userdao.getUserByName(username);
          if (user == null || user.equals((Object)null) || user.getUserName() == null)
            user = userdao.addUserByNameRole(username, role); 
          CBSystemConstants.setUser(user);
        } 
        if (map.containsKey("czpid"))
          CBSystemConstants.setImportInfo(map.get("czpid")); 
        if (map.containsKey("jxpid"))
          CBSystemConstants.jxpID = map.get("jxpid"); 
        if (map.containsKey("ddpid"))
          CBSystemConstants.ddpID = map.get("ddpid"); 
        if (map.containsKey("ddlid"))
          CBSystemConstants.ddzlID = map.get("ddlid"); 
        if (SystemConstants.getMainFrame() != null) {
          ExampleBuilder aa = (ExampleBuilder)SystemConstants.getGuiBuilder();
          if (aa != null)
            aa.reInitUser(null); 
        } 
      } 
    } else if (str.startsWith("tellhowczp://") || str.startsWith("httpczp://")) {
      String info = str.replace("tellhowczp://", "").replace("/", "").replace("\\", "");
      String[] arr = info.split("&");
      String czpID = arr[0];
      String username = arr[1];
      try {
        username = URLDecoder.decode(username, "UTF-8");
      } catch (UnsupportedEncodingException e) {
        e.printStackTrace();
      } 
      String role = arr[2];
      CBSystemConstants.roleCode = role;
      String ddzlID = "";
      if (arr.length > 3)
        ddzlID = arr[3]; 
      UserDao userdao = new UserDao();
      User user = userdao.getUserByName(username);
      if (user == null || user.equals((Object)null) || user.getUserName() == null)
        user = userdao.addUserByNameRole(username, role); 
      CBSystemConstants.setUser(user);
      CBSystemConstants.setImportInfo(czpID);
      CBSystemConstants.ddzlID = ddzlID;
      if (SystemConstants.getMainFrame() != null) {
        ExampleBuilder aa = (ExampleBuilder)SystemConstants.getGuiBuilder();
        aa.reInitUser(null);
      } 
    } 
    if (!CBSystemConstants.ddpID.equals("")) {
      List<Map> list = DBManager.queryForList(
          "select czdw,cznr from " + CBSystemConstants.opcardUser + "t_a_czpmx a where a.f_zbid='" + CBSystemConstants.ddpID + "'");
      for (int i = 0; i < list.size(); i++) {
        String czdw = ((Map)list.get(i)).get("czdw").toString();
        if (czdw.indexOf("监控") >= 0) {
          String cznr = ((Map)list.get(i)).get("cznr").toString();
          if (CBSystemConstants.ddzl.equals("")) {
            CBSystemConstants.ddzl = "<br>" + cznr;
          } else {
            CBSystemConstants.ddzl = String.valueOf(CBSystemConstants.ddzl) + "<br>" + cznr;
          } 
          CBSystemConstants.rbmList.addAll(CZPService.getCheckService().getRBMList(cznr));
        } 
      } 
    } else if (!CBSystemConstants.ddzlID.equals("")) {
      List<Map> list = DBManager.queryForList(
          "select czdw,cznr from " + CBSystemConstants.opcardUser + "t_a_czpmx a where a.mxid='" + CBSystemConstants.ddzlID + "'");
      for (int i = 0; i < list.size(); i++) {
        String czdw = ((Map)list.get(i)).get("czdw").toString();
        if (czdw.indexOf("监控") >= 0) {
          String cznr = ((Map)list.get(i)).get("cznr").toString();
          if (CBSystemConstants.ddzl.equals("")) {
            CBSystemConstants.ddzl = "<br>" + cznr;
          } else {
            CBSystemConstants.ddzl = String.valueOf(CBSystemConstants.ddzl) + "<br>" + cznr;
          } 
          CBSystemConstants.rbmList.addAll(CZPService.getCheckService().getRBMList(cznr));
        } 
      } 
    } 
  }
  
  public String getDevNameInit(PowerDevice pd) {
    String devName = pd.getPowerDeviceName();
    devName = devName.replaceAll("kVIII", "kVⅢ");
    devName = devName.replaceAll("kVII", "kVⅡ");
    devName = devName.replaceAll("kVI", "kVⅠ");
    devName = devName.replaceAll("IV", "Ⅳ");
    devName = devName.replaceAll("III", "Ⅲ");
    devName = devName.replaceAll("II", "Ⅱ");
    devName = devName.replaceAll("I", "Ⅰ");
    return devName;
  }
  
  public String getDevName(PowerDevice pd) {
    String devName = pd.getPowerDeviceName();
    if (devName.lastIndexOf(".") >= 0)
      devName = devName.substring(devName.lastIndexOf(".") + 1); 
    String deviceType = pd.getDeviceType();
    String deviceRunType = pd.getDeviceRunType();
    String voltName = StringUtils.getVolt(pd.getPowerVoltGrade());
    if (pd.getDeviceType().equals(SystemConstants.Switch)) {
      String devNum = StringUtils.getSwitchCode(devName);
      if (deviceRunType.equals("lineswitch") || deviceRunType.equals("hightransswitch") || deviceRunType.equals("lowtransswitch")) {
        if (pd.getDeviceRunModel().equals("runmodelthreetwo")) {
          List<PowerDevice> port1List = RuleExeUtil.getDeviceList(pd, String.valueOf(SystemConstants.PowerTransformer) + "," + SystemConstants.InOutLine, String.valueOf(SystemConstants.PowerTransformer) + "," + SystemConstants.Switch, 
              "", "", false, true, true, true, "1");
          List<PowerDevice> port2List = RuleExeUtil.getDeviceList(pd, String.valueOf(SystemConstants.PowerTransformer) + "," + SystemConstants.InOutLine, String.valueOf(SystemConstants.PowerTransformer) + "," + SystemConstants.Switch, 
              "", "", false, true, true, true, "2");
          if (port1List.size() > 0 && port2List.size() > 0) {
            List<PowerDevice> mxList1 = RuleExeUtil.getDeviceList(port1List.get(0), pd, SystemConstants.MotherLine, "", "", "", false, true, true, true);
            if (mxList1.size() > 0) {
              boolean hasTwoMother = false;
              for (PowerDevice mx : mxList1) {
                if (mx.getPowerVoltGrade() == pd.getPowerVoltGrade() && 
                  mx.getPowerDeviceName().contains("Ⅱ")) {
                  hasTwoMother = true;
                  break;
                } 
              } 
              if (hasTwoMother) {
                List<PowerDevice> temp = port1List;
                port1List = port2List;
                port2List = temp;
              } 
            } 
          } 
          boolean needTemp = false;
          if (!CollectionUtils.isEmpty(port1List) && !CollectionUtils.isEmpty(port2List) && 
            port1List.get(0) != null && port2List.get(0) != null && 
            SystemConstants.PowerTransformer.equals(((PowerDevice)port1List.get(0)).getDeviceType()) && SystemConstants.InOutLine.equals(((PowerDevice)port2List.get(0)).getDeviceType()))
            needTemp = true; 
          if (needTemp) {
            List<PowerDevice> temp = port1List;
            port1List = port2List;
            port2List = temp;
          } 
          String devN = "";
          for (PowerDevice dev : port1List) {
            if (!"".equals(devN))
              devN = String.valueOf(devN) + "/"; 
            if (dev.getDeviceType().equals(SystemConstants.InOutLine)) {
              devN = String.valueOf(devN) + getLineName(dev);
              continue;
            } 
            devN = String.valueOf(devN) + getDevName(dev);
          } 
          for (PowerDevice dev : port2List) {
            if (!"".equals(devN))
              devN = String.valueOf(devN) + "/"; 
            if (dev.getDeviceType().equals(SystemConstants.InOutLine)) {
              devN = String.valueOf(devN) + getLineName(dev);
              continue;
            } 
            devN = String.valueOf(devN) + getDevName(dev);
          } 
          devNum = String.valueOf(devN) + devNum;
        } else {
          List<PowerDevice> tfList = RuleExeUtil.getDeviceList(pd, SystemConstants.PowerTransformer, SystemConstants.PowerTransformer, true, true, true);
          if (pd.getPowerDeviceID().equals("114560316292989592"))
            tfList = RuleExeUtil.getDeviceList(pd, SystemConstants.PowerTransformer, SystemConstants.PowerTransformer, true, false, true); 
          if (tfList.size() > 0) {
            String devN = getDevName(tfList.get(0));
            List<PowerDevice> xlList = RuleExeUtil.getDeviceList(pd, SystemConstants.InOutLine, SystemConstants.Switch, true, true, true);
            if (xlList.size() > 0)
              devN = String.valueOf(getLineName(xlList.get(0))) + "/" + devN; 
            devNum = String.valueOf(devN) + devNum;
          } else if (deviceRunType.equals("lineswitch")) {
            List<PowerDevice> lineList = RuleExeUtil.getDeviceList(pd, SystemConstants.InOutLine, SystemConstants.PowerTransformer, true, true, true);
            if (lineList.size() == 1)
              devNum = String.valueOf(getLineName(lineList.get(0))) + devNum; 
          } 
        } 
      } else if (deviceRunType.equals("monthlinelinkswitch")) {
        boolean isSpecial = false;
        if (voltName.equals("35kV")) {
          List<PowerDevice> mxList = RuleExeUtil.getDeviceList(pd, SystemConstants.MotherLine, SystemConstants.PowerTransformer, true, true, true);
          for (PowerDevice mx : mxList) {
            List<PowerDevice> zbList = RuleExeUtil.getDeviceDirectList(mx, SystemConstants.PowerTransformer);
            if (!CollectionUtils.isEmpty(zbList)) {
              devNum = String.valueOf(getDevNum(zbList.get(0))) + "主变" + devNum;
              isSpecial = true;
            } 
          } 
        } 
        if (!isSpecial)
          if (RuleExeUtil.isSwitchDoubleML(pd)) {
            devNum = "母联" + devNum;
          } else {
            devNum = "分段" + devNum;
          }  
      } else if (deviceRunType.equals("sidelineswitch")) {
        devNum = "旁路" + devNum;
      } else if (deviceRunType.equals("dianrongswitch") || deviceRunType.equals("diankangswitch")) {
        List<PowerDevice> drdkList = RuleExeUtil.getDeviceList(pd, String.valueOf(SystemConstants.ElecCapacity) + "," + SystemConstants.ElecShock, SystemConstants.PowerTransformer, true, true, true);
        if (drdkList.size() == 1) {
          String drdkName = getDevName2(drdkList.get(0));
          devNum = String.valueOf(drdkName) + devNum;
        } 
      } 
      devName = devNum.concat("开关");
    } else if (pd.getDeviceType().equals(SystemConstants.MotherLine)) {
      String devNum = getDevNum(devName);
      if (deviceRunType.equals("sidemotherline"))
        devNum = "旁路" + devNum; 
      devName = String.valueOf(voltName) + devNum + "母";
    } else if (pd.getDeviceType().equals(SystemConstants.PowerTransformer)) {
      List<PowerDevice> fdj = RuleExeUtil.getDeviceList(pd, SystemConstants.PowerGenerator, SystemConstants.Switch, 
          true, false, true);
      String devNum = getDevNum(devName);
      if (!fdj.isEmpty()) {
        devName = String.valueOf(devNum) + "发变组";
      } else if (devName.contains("启备变")) {
        devName = String.valueOf(devNum) + "启备变";
      } else {
        devName = String.valueOf(devNum) + "主变";
      } 
    } else if (StringUtils.compareStr(deviceType, SystemConstants.SwitchSeparate) == 0) {
      String devNum = getDevNum(devName);
      if (pd.getPowerVoltGrade() == 500.0D) {
        List<PowerDevice> kgList = RuleExeUtil.getDeviceDirectList(pd, SystemConstants.Switch);
        for (PowerDevice dev : kgList) {
          if (dev.getPowerDeviceName().contains("联络")) {
            String headword = dev.getPowerDeviceName().substring(0, dev.getPowerDeviceName().indexOf("联络") + 2);
            devName = String.valueOf(headword) + devNum + "刀闸";
            continue;
          } 
          if (dev.getPowerDeviceName().contains("主变")) {
            String headword = dev.getPowerDeviceName().substring(0, dev.getPowerDeviceName().indexOf("主变") + 2);
            devName = String.valueOf(headword) + voltName + "侧" + devNum + "刀闸";
          } 
        } 
        if (CollectionUtils.isEmpty(kgList)) {
          List<PowerDevice> lineList = RuleExeUtil.getDeviceList(pd, SystemConstants.InOutLine, SystemConstants.PowerTransformer, true, true, true);
          for (PowerDevice dev : lineList) {
            String lineName = getDevName2(lineList.get(0));
            lineName = lineName.replace("回线", "线");
            devName = String.valueOf(voltName) + lineName + devNum + "刀闸";
          } 
        } 
      } else {
        if (deviceRunType.equals("monthlineknife")) {
          List<PowerDevice> kgList = RuleExeUtil.getDeviceDirectList(pd, SystemConstants.Switch);
          for (PowerDevice dev : kgList) {
            if (dev.getDeviceRunType().equals("hightransswitch") || dev.getDeviceRunType().equals("lowtransswitch")) {
              List<PowerDevice> zbList = RuleExeUtil.getDeviceList(dev, SystemConstants.PowerTransformer, 
                  SystemConstants.PowerTransformer, true, true, true);
              if (zbList.size() > 0) {
                String zbname = getDevName2(zbList.get(0));
                if (!zbname.equals(""))
                  devName = String.valueOf(zbname) + voltName + "侧" + devNum + "刀闸"; 
              } 
              continue;
            } 
            if (dev.getDeviceRunType().equals("lineswitch")) {
              List<PowerDevice> lineList = RuleExeUtil.getDeviceList(dev, SystemConstants.InOutLine, 
                  SystemConstants.PowerTransformer, true, true, true);
              if (lineList.size() > 0) {
                String linename = getDevName2(lineList.get(0));
                devName = String.valueOf(linename) + devNum + "刀闸";
              } 
              continue;
            } 
            if (dev.getDeviceRunType().equals("diankangswitch")) {
              List<PowerDevice> dkqList = RuleExeUtil.getDeviceList(pd, SystemConstants.ElecShock, SystemConstants.PowerTransformer, true, true, true);
              if (dkqList.size() > 0) {
                String dkqName = getDevName2(dkqList.get(0));
                devName = String.valueOf(dkqName) + devNum + "刀闸";
              } 
              continue;
            } 
            if (dev.getDeviceRunType().equals("dianrongswitch")) {
              List<PowerDevice> drqList = RuleExeUtil.getDeviceList(pd, SystemConstants.ElecCapacity, SystemConstants.PowerTransformer, true, true, true);
              if (drqList.size() > 0) {
                String drqName = getDevName2(drqList.get(0));
                devName = String.valueOf(drqName) + devNum + "刀闸";
              } 
              continue;
            } 
            if (dev.getDeviceRunType().equals("zhanyongbianswitch")) {
              List<PowerDevice> zybList = RuleExeUtil.getDeviceList(pd, SystemConstants.Term, SystemConstants.PowerTransformer, true, true, true);
              if (zybList.size() > 0) {
                String zybName = getDevName2(zybList.get(0));
                devName = String.valueOf(zybName) + devNum + "刀闸";
              } 
              continue;
            } 
            if (dev.getDeviceRunType().equals("monthlinelinkswitch")) {
              if (RuleExeUtil.isSwitchDoubleML(pd)) {
                devName = String.valueOf(voltName) + "母联" + devNum + "刀闸";
                continue;
              } 
              devName = String.valueOf(voltName) + "分段" + devNum + "刀闸";
            } 
          } 
        } else if (deviceRunType.equals("powerknife")) {
          List<PowerDevice> kgList = RuleExeUtil.getDeviceDirectList(pd, SystemConstants.Switch);
          for (PowerDevice dev : kgList) {
            if (dev.getDeviceRunType().equals("lineswitch")) {
              List<PowerDevice> lineList = RuleExeUtil.getDeviceList(dev, SystemConstants.InOutLine, 
                  SystemConstants.PowerTransformer, true, true, true);
              if (lineList.size() > 0) {
                String linename = getDevName2(lineList.get(0));
                devName = String.valueOf(linename) + devNum + "刀闸";
              } 
            } 
          } 
        } else if (deviceRunType.equals("transknife")) {
          List<PowerDevice> zbList = RuleExeUtil.getDeviceDirectList(pd, SystemConstants.PowerTransformer);
          if (zbList.size() > 0) {
            String zbname = getDevName2(zbList.get(0));
            devName = devName.replace("测", "侧");
            if ((deviceRunType.equals("transknife") || deviceRunType.equals("transknifeforswtich")) && 
              !devName.contains("侧"))
              devName = devName.replace("主变", "主变侧"); 
            if (devName.contains("侧")) {
              devName = String.valueOf(zbname) + voltName + "侧" + devNum + "刀闸";
            } else if (devName.contains("主变")) {
              devName = String.valueOf(voltName) + devName;
            } else {
              devName = String.valueOf(zbname) + voltName + "侧" + devName;
            } 
          } 
        } else if (deviceRunType.equals("lineknife")) {
          List<PowerDevice> xlList = RuleExeUtil.getDeviceDirectList(pd, SystemConstants.InOutLine);
          if (xlList.size() > 0) {
            devName = String.valueOf(getDevName2(xlList.get(0))) + devNum;
            if (pd.getPowerVoltGrade() > 100.0D)
              devName = String.valueOf(devName) + "进线"; 
            devName = String.valueOf(devName) + "刀闸";
          } 
        } else if (!deviceRunType.equals("ptknife")) {
          devName = devName.replace("线路侧", "");
        } 
        if (devName.contains("主变")) {
          List<PowerDevice> zbList = RuleExeUtil.getDeviceDirectList(pd, SystemConstants.PowerTransformer);
          if (zbList.size() > 0) {
            String zbname = getDevName2(zbList.get(0));
            devName = devName.replace("测", "侧");
            if ((deviceRunType.equals("transknife") || deviceRunType.equals("transknifeforswtich")) && 
              !devName.contains("侧"))
              devName = devName.replace("主变", "主变侧"); 
            if (devName.contains("侧")) {
              devName = String.valueOf(zbname) + voltName + devName.substring(devName.lastIndexOf("侧"), devName.length());
            } else if (devName.contains("主变")) {
              devName = String.valueOf(zbname) + voltName + "侧" + devNum + "刀闸";
            } else {
              devName = String.valueOf(zbname) + voltName + devName;
            } 
          } else if (devName.contains("主变") && !devName.contains("kV")) {
            zbList = RuleExeUtil.getDeviceList(pd, SystemConstants.PowerTransformer, SystemConstants.MotherLine, true, true, true);
            if (zbList.size() > 0) {
              devName = String.valueOf((int)((PowerDevice)zbList.get(0)).getPowerVoltGrade()) + "kV" + devName;
              if (devName.contains("低压侧")) {
                devName = devName.replace("低压侧", String.valueOf((int)pd.getPowerVoltGrade()) + "kV" + "侧");
              } else if (devName.contains("高压侧")) {
                devName = devName.replace("高压侧", String.valueOf((int)pd.getPowerVoltGrade()) + "kV" + "侧");
              } 
            } 
          } 
        } 
        if (!devName.endsWith("刀闸") && 
          !deviceRunType.equals("transknife")) {
          List<PowerDevice> lineList = RuleExeUtil.getDeviceList(pd, SystemConstants.InOutLine, SystemConstants.PowerTransformer, true, true, true);
          if (lineList.size() > 0)
            devName = String.valueOf(getDevName2(lineList.get(0))) + devNum + "刀闸"; 
        } 
      } 
    } else if (StringUtils.compareStr(deviceType, SystemConstants.SwitchFlowGroundLine) == 0) {
      if (deviceRunType.equals("neutralgroundknife")) {
        String devNum = getDevNum(devName);
        List<PowerDevice> tfList = RuleExeUtil.getDeviceDirectList(pd, SystemConstants.PowerTransformer);
        if (tfList.size() == 1)
          devNum = String.valueOf(getDevName2(tfList.get(0))) + voltName + "侧中性点" + devNum; 
        devName = devNum.concat("接地刀闸");
      } 
    } else if (StringUtils.compareStr(deviceType, SystemConstants.InOutLine) == 0) {
      List<PowerDevice> devList = RuleExeUtil.getDeviceList(pd, SystemConstants.Switch, SystemConstants.PowerTransformer, true, true, true);
      if (pd.getPowerVoltGrade() < 500.0D) {
        if (!CollectionUtils.isEmpty(devList)) {
          PowerDevice lineSwitch = devList.get(0);
          String devNum = getDevNum(lineSwitch);
          devName = devName.replace("回线", "线");
          devName = String.valueOf(voltName) + devNum + devName + "线路";
        } 
      } else if (pd.getPowerVoltGrade() == 500.0D && 
        !CollectionUtils.isEmpty(devList)) {
        if (devList.size() == 2) {
          String switchNum = "";
          for (PowerDevice dev : devList) {
            String devNum = getDevNum(dev);
            if (!devNum.endsWith("2"))
              switchNum = String.valueOf(switchNum) + devNum + "/"; 
          } 
          for (PowerDevice dev : devList) {
            String devNum = getDevNum(dev);
            if (devNum.endsWith("2"))
              switchNum = String.valueOf(switchNum) + devNum; 
          } 
          devName = devName.replace("回线", "线");
          devName = String.valueOf(switchNum) + devName + "线路";
        } else {
          PowerDevice lineSwitch = devList.get(0);
          String devNum = getDevNum(lineSwitch);
          devName = devName.replace("回线", "线");
          devName = String.valueOf(devNum) + devName + "线路";
        } 
      } 
    } else if (StringUtils.compareStr(deviceType, SystemConstants.ElecCapacity) == 0) {
      String devNum = getDevNum(devName);
      devName = String.valueOf(voltName) + devNum + "电容器";
    } else if (StringUtils.compareStr(deviceType, SystemConstants.ElecShock) == 0) {
      String devNum = getDevNum(devName);
      devName = String.valueOf(voltName) + devNum + "电抗器";
    } else if (StringUtils.compareStr(deviceType, SystemConstants.EarthingTransformer) == 0) {
      String devNum = getDevNum(devName);
      devName = String.valueOf(voltName) + devNum + "接地变";
    } 
    return devName;
  }
  
  public String getLineName(PowerDevice line) {
    String devName = line.getPowerDeviceName();
    if (devName.lastIndexOf(".") >= 0)
      devName = devName.substring(devName.lastIndexOf(".") + 1); 
    devName = devName.replace("回线", "线");
    if (line.getPowerVoltGrade() < 500.0D) {
      String voltName = StringUtils.getVolt(line.getPowerVoltGrade());
      if (!devName.contains("kV"))
        devName = String.valueOf(voltName) + devName; 
    } 
    return devName;
  }
  
  public String getDevName2(PowerDevice pd) {
    String devName = pd.getPowerDeviceName();
    if (devName.lastIndexOf(".") >= 0)
      devName = devName.substring(devName.lastIndexOf(".") + 1); 
    String deviceType = pd.getDeviceType();
    String deviceRunType = pd.getDeviceRunType();
    String voltName = StringUtils.getVolt(pd.getPowerVoltGrade());
    if (pd.getDeviceType().equals(SystemConstants.Switch)) {
      if (devName.contains("开关")) {
        devName = String.valueOf(devName.replace("开关", "")) + "开关";
      } else {
        devName = String.valueOf(devName) + "开关";
      } 
      if (pd.getDeviceRunType().equals("monthlinelinkswitch")) {
        String devNum = getDevNum(devName);
        if (RuleExeUtil.isSwitchDoubleML(pd)) {
          devName = String.valueOf(voltName) + "母联" + devNum + "开关";
        } else {
          String mxNames = "";
          if (devName.contains("M")) {
            if (devNum.length() > 2) {
              String last2Num = devNum.substring(devNum.length() - 2, devNum.length());
              for (int i = 0; i < last2Num.length(); i++) {
                char num = last2Num.charAt(i);
                mxNames = String.valueOf(mxNames) + "#" + num + "M、";
              } 
              if (mxNames.endsWith("、"))
                mxNames = mxNames.substring(0, mxNames.length() - 1); 
              mxNames = String.valueOf(mxNames) + "母线";
            } 
          } else {
            List<PowerDevice> mxList = new ArrayList<PowerDevice>();
            HashMap<String, PowerDevice> mapStationDevice = CBSystemConstants.getStationPowerDevices(pd.getPowerStationID());
            for (Iterator<PowerDevice> it = mapStationDevice.values().iterator(); it.hasNext(); ) {
              PowerDevice dev = it.next();
              if (dev.getDeviceType().equals(SystemConstants.MotherLine) && 
                dev.getPowerVoltGrade() == pd.getPowerVoltGrade())
                mxList.add(dev); 
            } 
            if (mxList.size() > 2) {
              String last2Num = devNum.substring(devNum.length() - 2, devNum.length());
              for (int i = 0; i < last2Num.length(); i++) {
                char num = last2Num.charAt(i);
                mxNames = String.valueOf(mxNames) + "#" + num + "M、";
              } 
              if (mxNames.endsWith("、"))
                mxNames = mxNames.substring(0, mxNames.length() - 1); 
              mxNames = String.valueOf(mxNames) + "母线";
            } 
          } 
          devName = String.valueOf(voltName) + mxNames + "分段" + devNum + "开关";
        } 
      } else if (pd.getDeviceRunType().equals("hightransswitch") || 
        pd.getDeviceRunType().equals("lowtransswitch")) {
        String devNum = getDevNum(devName);
        if (!pd.getDeviceRunModel().equals("runmodelthreetwo")) {
          List<PowerDevice> lineList = RuleExeUtil.getDeviceList(pd, SystemConstants.InOutLine, SystemConstants.PowerTransformer, true, true, true);
          List<PowerDevice> zbList = RuleExeUtil.getDeviceList(pd, SystemConstants.PowerTransformer, SystemConstants.PowerTransformer, true, true, true);
          if (lineList.size() > 0) {
            devName = String.valueOf(getDevName(lineList.get(0))) + devNum + "开关";
          } else if (zbList.size() > 0) {
            String zbname = getDevName(zbList.get(0));
            devName = String.valueOf(zbname) + voltName + "侧" + devNum + "开关";
          } 
        } 
      } else if (pd.getDeviceRunType().equals("lineswitch")) {
        List<PowerDevice> lineList = RuleExeUtil.getDeviceList(pd, SystemConstants.InOutLine, SystemConstants.PowerTransformer, true, true, true);
        if (lineList.size() > 0) {
          String devNum = getDevNum(devName);
          devName = String.valueOf(voltName) + getDevName(lineList.get(0)) + devNum + "开关";
        } 
      } 
    } else if (pd.getDeviceType().equals(SystemConstants.MotherLine)) {
      String devNum = getDevNum(devName);
      if (deviceRunType.equals("sidemotherline"))
        devNum = "旁路" + devNum; 
      devName = String.valueOf(voltName) + devNum + "母";
    } else if (pd.getDeviceType().equals(SystemConstants.PowerTransformer)) {
      String devNum = getDevNum(devName);
      devName = String.valueOf(devNum) + "主变";
    } else if (pd.getDeviceType().equals(SystemConstants.PowerStation)) {
      if (devName.contains("福山站"))
        devName = String.valueOf(voltName) + devName; 
    } else if (pd.getDeviceType().equals(SystemConstants.PowerFactory)) {
      if (devName.contains("牛路岭"))
        devName = "牛路岭水电厂"; 
    } else if (StringUtils.compareStr(deviceType, SystemConstants.SwitchSeparate) == 0) {
      String devNum = getDevNum(devName);
      if (pd.getPowerVoltGrade() == 500.0D) {
        List<PowerDevice> kgList = RuleExeUtil.getDeviceDirectList(pd, SystemConstants.Switch);
        for (PowerDevice dev : kgList) {
          if (dev.getPowerDeviceName().contains("联络")) {
            String headword = dev.getPowerDeviceName().substring(0, dev.getPowerDeviceName().indexOf("联络") + 2);
            devName = String.valueOf(headword) + devNum + "刀闸";
            continue;
          } 
          if (dev.getPowerDeviceName().contains("主变")) {
            String headword = dev.getPowerDeviceName().substring(0, dev.getPowerDeviceName().indexOf("主变") + 2);
            devName = String.valueOf(headword) + voltName + "侧" + devNum + "刀闸";
          } 
        } 
      } else {
        if (deviceRunType.equals("monthlineknife")) {
          List<PowerDevice> kgList = RuleExeUtil.getDeviceDirectList(pd, SystemConstants.Switch);
          for (PowerDevice dev : kgList) {
            if (dev.getDeviceRunType().equals("hightransswitch") || dev.getDeviceRunType().equals("lowtransswitch")) {
              List<PowerDevice> zbList = RuleExeUtil.getDeviceList(dev, SystemConstants.PowerTransformer, 
                  SystemConstants.PowerTransformer, true, true, true);
              if (zbList.size() > 0) {
                String zbname = getDevName(zbList.get(0));
                if (!zbname.equals(""))
                  devName = String.valueOf(zbname) + voltName + "侧" + devNum + "刀闸"; 
              } 
              continue;
            } 
            if (dev.getDeviceRunType().equals("lineswitch")) {
              List<PowerDevice> lineList = RuleExeUtil.getDeviceList(dev, SystemConstants.InOutLine, 
                  SystemConstants.PowerTransformer, true, true, true);
              if (lineList.size() > 0) {
                String linename = getDevName(lineList.get(0));
                devName = String.valueOf(linename) + devNum + "刀闸";
              } 
              continue;
            } 
            if (dev.getDeviceRunType().equals("diankangswitch")) {
              List<PowerDevice> dkqList = RuleExeUtil.getDeviceList(pd, SystemConstants.ElecShock, SystemConstants.PowerTransformer, true, true, true);
              if (dkqList.size() > 0) {
                String dkqName = getDevName(dkqList.get(0));
                devName = String.valueOf(dkqName) + devNum + "刀闸";
              } 
              continue;
            } 
            if (dev.getDeviceRunType().equals("dianrongswitch")) {
              List<PowerDevice> drqList = RuleExeUtil.getDeviceList(pd, SystemConstants.ElecCapacity, SystemConstants.PowerTransformer, true, true, true);
              if (drqList.size() > 0) {
                String drqName = getDevName(drqList.get(0));
                devName = String.valueOf(drqName) + devNum + "刀闸";
              } 
              continue;
            } 
            if (dev.getDeviceRunType().equals("zhanyongbianswitch")) {
              List<PowerDevice> zybList = RuleExeUtil.getDeviceList(pd, SystemConstants.Term, SystemConstants.PowerTransformer, true, true, true);
              if (zybList.size() > 0) {
                String zybName = getDevName(zybList.get(0));
                devName = String.valueOf(zybName) + devNum + "刀闸";
              } 
              continue;
            } 
            if (dev.getDeviceRunType().equals("monthlinelinkswitch")) {
              if (RuleExeUtil.isSwitchDoubleML(pd)) {
                devName = String.valueOf(voltName) + "母联" + devNum + "刀闸";
                continue;
              } 
              devName = String.valueOf(voltName) + "分段" + devNum + "刀闸";
            } 
          } 
        } else if (deviceRunType.equals("powerknife")) {
          List<PowerDevice> kgList = RuleExeUtil.getDeviceDirectList(pd, SystemConstants.Switch);
          for (PowerDevice dev : kgList) {
            if (dev.getDeviceRunType().equals("lineswitch")) {
              List<PowerDevice> lineList = RuleExeUtil.getDeviceList(dev, SystemConstants.InOutLine, 
                  SystemConstants.PowerTransformer, true, true, true);
              if (lineList.size() > 0) {
                String linename = getDevName(lineList.get(0));
                devName = String.valueOf(linename) + devNum + "刀闸";
              } 
            } 
          } 
        } else if (deviceRunType.equals("transknife")) {
          List<PowerDevice> zbList = RuleExeUtil.getDeviceDirectList(pd, SystemConstants.PowerTransformer);
          if (zbList.size() > 0) {
            String zbname = getDevName(zbList.get(0));
            devName = devName.replace("测", "侧");
            if ((deviceRunType.equals("transknife") || deviceRunType.equals("transknifeforswtich")) && 
              !devName.contains("侧"))
              devName = devName.replace("主变", "主变侧"); 
            if (devName.contains("侧")) {
              devName = String.valueOf(zbname) + voltName + "侧" + devNum + "刀闸";
            } else if (devName.contains("主变")) {
              devName = String.valueOf(voltName) + devName;
            } else {
              devName = String.valueOf(zbname) + voltName + "侧" + devName;
            } 
          } 
        } else if (deviceRunType.equals("lineknife")) {
          List<PowerDevice> xlList = RuleExeUtil.getDeviceDirectList(pd, SystemConstants.InOutLine);
          if (xlList.size() > 0) {
            devName = String.valueOf(CZPService.getCheckService().getDevName(xlList.get(0))) + devNum;
            if (pd.getPowerVoltGrade() > 100.0D)
              devName = String.valueOf(devName) + "进线"; 
            devName = String.valueOf(devName) + "刀闸";
          } 
        } else if (!deviceRunType.equals("ptknife")) {
          devName = devName.replace("线路侧", "");
        } 
        if (devName.contains("主变")) {
          List<PowerDevice> zbList = RuleExeUtil.getDeviceDirectList(pd, SystemConstants.PowerTransformer);
          if (zbList.size() > 0) {
            String zbname = getDevName(zbList.get(0));
            devName = devName.replace("测", "侧");
            if ((deviceRunType.equals("transknife") || deviceRunType.equals("transknifeforswtich")) && 
              !devName.contains("侧"))
              devName = devName.replace("主变", "主变侧"); 
            if (devName.contains("侧")) {
              devName = String.valueOf(zbname) + voltName + devName.substring(devName.lastIndexOf("侧"), devName.length());
            } else if (devName.contains("主变")) {
              devName = String.valueOf(zbname) + voltName + "侧" + devNum + "刀闸";
            } else {
              devName = String.valueOf(zbname) + voltName + devName;
            } 
          } else if (devName.contains("主变") && !devName.contains("kV")) {
            zbList = RuleExeUtil.getDeviceList(pd, SystemConstants.PowerTransformer, SystemConstants.MotherLine, true, true, true);
            if (zbList.size() > 0) {
              devName = String.valueOf((int)((PowerDevice)zbList.get(0)).getPowerVoltGrade()) + "kV" + devName;
              if (devName.contains("低压侧")) {
                devName = devName.replace("低压侧", String.valueOf((int)pd.getPowerVoltGrade()) + "kV" + "侧");
              } else if (devName.contains("高压侧")) {
                devName = devName.replace("高压侧", String.valueOf((int)pd.getPowerVoltGrade()) + "kV" + "侧");
              } 
            } 
          } 
        } 
        if (!devName.endsWith("刀闸") && 
          !deviceRunType.equals("transknife")) {
          List<PowerDevice> lineList = RuleExeUtil.getDeviceList(pd, SystemConstants.InOutLine, SystemConstants.PowerTransformer, true, true, true);
          if (lineList.size() > 0)
            devName = String.valueOf(CZPService.getCheckService().getDevName(lineList.get(0))) + devNum + "刀闸"; 
        } 
      } 
    } else if (StringUtils.compareStr(deviceType, SystemConstants.SwitchFlowGroundLine) == 0) {
      if (deviceRunType.equals("neutralgroundknife")) {
        String devNum = getDevNum(devName);
        List<PowerDevice> tfList = RuleExeUtil.getDeviceDirectList(pd, SystemConstants.PowerTransformer);
        if (tfList.size() == 1)
          devNum = String.valueOf(getDevName(tfList.get(0))) + voltName + "侧中性点" + devNum; 
        devName = devNum.concat("接地刀闸");
      } 
    } else if (StringUtils.compareStr(deviceType, SystemConstants.InOutLine) != 0) {
      if (StringUtils.compareStr(deviceType, SystemConstants.ElecCapacity) != 0)
        if (StringUtils.compareStr(deviceType, SystemConstants.ElecShock) == 0) {
          String devNum = getDevNum(devName);
          devName = String.valueOf(voltName) + devName;
        } else if (StringUtils.compareStr(deviceType, SystemConstants.EarthingTransformer) == 0) {
          String devNum = getDevNum(devName);
          devName = String.valueOf(voltName) + devName;
        }  
    } 
    return devName;
  }
  
  private String getStatusCode(String status) {
    String stateCode = "";
    if ("0".equals(status)) {
      stateCode = "运行";
    } else if ("1".equals(status)) {
      stateCode = "热备用";
    } else if ("2".equals(status)) {
      stateCode = "冷备用";
    } else if ("3".equals(status)) {
      stateCode = "检修";
    } else if ("运行".equals(status)) {
      stateCode = "0";
    } else if ("热备用".equals(status)) {
      stateCode = "1";
    } else if ("冷备用".equals(status)) {
      stateCode = "2";
    } else if ("检修".equals(status)) {
      stateCode = "3";
    } else {
      try {
        Integer.parseInt(status);
      } catch (NumberFormatException e) {
        stateCode = "-1";
      } 
    } 
    return stateCode;
  }
  
  private void fillRepeatList(PowerDevice pd, List<PowerDevice> lineList, List<PowerDevice> switchList) {
    lineList.add(pd);
    List<PowerDevice> swList = RuleExeUtil.getDeviceList(pd, SystemConstants.Switch, SystemConstants.PowerTransformer, "lineswitch", "", false, true, true, true);
    switchList.addAll(swList);
  }
  
  private Map<String, String> decomposeXmlNode(Element root) {
    Map<String, String> nodeMap = new HashMap<String, String>();
    List<Element> roleList = root.elements("role");
    if (!roleList.isEmpty())
      CBSystemConstants.roleCode = ((Element)roleList.get(0)).getTextTrim(); 
    List<Element> qybmList = root.elements("areano");
    if (!qybmList.isEmpty()) {
      CBSystemConstants.qybm = ((Element)qybmList.get(0)).getTextTrim();
      CBSystemConstants.unitCode = ((Element)qybmList.get(0)).getTextTrim();
      CBSystemConstants.opCode = QueryDeviceDao.getOpcode(CBSystemConstants.unitCode, CBSystemConstants.roleCode);
      if (CBSystemConstants.opCode.isEmpty())
        CBSystemConstants.opCode = QueryDeviceDao.getOpcode("0", CBSystemConstants.roleCode); 
      CBSystemConstants.opRuleCode = CBSystemConstants.opCode;
    } 
    fillNodeContent(root, "czrw", nodeMap);
    fillNodeContent(root, "operation", nodeMap);
    fillNodeContent(root, "firststation", nodeMap);
    return nodeMap;
  }
  
  private void fillNodeContent(Element root, String keyword, Map<String, String> nodeMap) {
    String node = "";
    List<Element> list = root.elements(keyword);
    if (!list.isEmpty())
      node = ((Element)list.get(0)).getTextTrim(); 
    nodeMap.put(keyword, node);
  }
  
  private void createEmptyPd(String equipname, String stationname, String beginstatus, String endstatus, List<PowerDevice> emptyPdList) {
    PowerDevice emptyPd = new PowerDevice();
    emptyPd.setPowerDeviceName(equipname);
    emptyPd.setPowerStationName(stationname);
    emptyPd.setDeviceStatus(beginstatus);
    emptyPd.setOpenStatus(endstatus);
    emptyPdList.add(emptyPd);
  }
  
  private String extractOptInstruction(String stationName, String equipName, String beginStatus, String endStatus) {
    String motion;
    if (beginStatus == null || beginStatus.isEmpty() || endStatus == null || endStatus.isEmpty()) {
      motion = "";
    } else {
      int begin = Integer.parseInt(beginStatus);
      int end = Integer.parseInt(endStatus);
      if (begin > end) {
        motion = "合上";
      } else if (begin < end) {
        motion = "拉开";
      } else {
        motion = "";
      } 
    } 
    return String.valueOf(stationName) + motion + equipName;
  }
  
  public String getCzdwId(String czdw, String cznr) {
    List<RuleBaseMode> rbmList;
    if (czdw.endsWith("监控")) {
      rbmList = getRBMList(cznr);
    } else {
      rbmList = getRBMList(czdw, cznr);
    } 
    if (rbmList.isEmpty())
      return ""; 
    return ((RuleBaseMode)rbmList.get(0)).getPd().getPowerStationID();
  }
  
  private String getStateCodeSql(String operation, PowerDevice dev) {
    String stateCodeSql;
    if ("线路运行转检修".equals(operation) || "线路检修转运行".equals(operation))
      operation = String.valueOf(operation) + "-线路"; 
    String commonWhereSql = " and t.cardbuildtype='0' and t.opcode='" + 
      CBSystemConstants.opCode + "' and t.devicetypeid='" + dev.getDeviceType() + "' and t.isLock = '0'";
    if (operation.contains("-")) {
      String[] menus = operation.split("-");
      String stateCodeSqlTemp = "select t.STATECODE from {0}T_A_DEVICESTATEINFO parent,      {0}T_A_DEVICESTATEINFO t where parent.STATECODE = t.PARENTCODE and parent.STATENAME=''{1}'' and t.STATENAME=''{2}''";
      stateCodeSql = MessageFormat.format(stateCodeSqlTemp, new Object[] { CBSystemConstants.opcardUser, menus[0], menus[1] });
    } else {
      stateCodeSql = "select t.statecode from " + CBSystemConstants.opcardUser + "t_a_devicestateinfo t where t.statename = '" + operation + "'";
    } 
    return String.valueOf(stateCodeSql) + commonWhereSql;
  }
  
  public String getDevName(List<PowerDevice> pdList) {
    String devName = "";
    if (pdList.size() > 0)
      if (((PowerDevice)pdList.get(0)).getDeviceType().equals(SystemConstants.MotherLine)) {
        String devNum = "";
        String voltName = StringUtils.getVolt(((PowerDevice)pdList.get(0)).getPowerVoltGrade());
        for (PowerDevice pd : pdList)
          devNum = String.valueOf(devNum) + getDevNum(pd.getPowerDeviceName()) + "、"; 
        devNum = devNum.substring(0, devNum.length() - 1);
        devName = String.valueOf(voltName) + " " + devNum + "母线";
      } else if (((PowerDevice)pdList.get(0)).getDeviceType().equals(SystemConstants.PowerTransformer)) {
        String devNum = "";
        for (PowerDevice pd : pdList)
          devNum = String.valueOf(devNum) + getDevNum(pd.getPowerDeviceName()) + "、"; 
        devNum = devNum.substring(0, devNum.length() - 1);
        devName = String.valueOf(devNum) + "主变";
      } else {
        for (PowerDevice pd : pdList)
          devName = String.valueOf(devName) + getDevName2(pd) + "、"; 
        if (!devName.equals(""))
          devName = devName.substring(0, devName.length() - 1); 
      }  
    return devName;
  }
  
  public void editMap(Document svgDoc, String fileName) {
    SVGDocumentResolver resolver = SVGDocumentResolver.getResolver();
    Element root = resolver.resolveSvgElement(svgDoc);
    NodeList svgDevNodeList = root.getElementsByTagName("g");
    Element breakLayer = svgDoc.getElementById("Breaker_Layer");
    Element dollyLayer = svgDoc.getElementById("DollyBreaker_Layer");
    Element disconnectorLayer = svgDoc.getElementById("Disconnector_Layer");
    if (breakLayer != null && disconnectorLayer != null)
      svgDoc.getDocumentElement().insertBefore(disconnectorLayer, breakLayer); 
    if (dollyLayer != null && disconnectorLayer != null) {
      svgDevNodeList = dollyLayer.getElementsByTagName("g");
      for (int i = 0; i < svgDevNodeList.getLength(); i++) {
        Element element = (Element)svgDevNodeList.item(i);
        String deviceName = resolver.getDeviceName(element);
        if (deviceName.contains("手车工作位置"))
          disconnectorLayer.appendChild(element); 
      } 
    } 
    if (dollyLayer != null) {
      NodeList dollySvgDevNodeList = dollyLayer.getElementsByTagName("g");
      for (int i = dollySvgDevNodeList.getLength() - 1; i >= 0; i--) {
        Element powerElement = (Element)dollySvgDevNodeList.item(i);
        dollyLayer.removeChild(powerElement);
        dollyLayer.appendChild(powerElement);
      } 
    } 
    Element text_Layer = svgDoc.getElementById("Text_Layer");
    if (text_Layer != null) {
      NodeList svgTextNodeList = text_Layer.getElementsByTagName("text");
      for (int i = 0; i < svgTextNodeList.getLength(); i++) {
        Element powerElement = (Element)svgTextNodeList.item(i);
        if (powerElement.getAttribute("stroke").equals("rgb(0,0,0)")) {
          powerElement.setAttribute("fill", "rgb(255,255,254)");
          powerElement.setAttribute("stroke", "rgb(255,255,254)");
          break;
        } 
        if (powerElement.getAttribute("stroke").equals("rgb(0,0,127)")) {
          powerElement.setAttribute("fill", "rgb(255,255,254)");
          powerElement.setAttribute("stroke", "rgb(255,255,254)");
          break;
        } 
      } 
    } 
  }
  
  public void setMapSVGFileDefault() {}
  
  public String getSecondLastDigit(String str) {
    Matcher matcher = Pattern.compile("\\d+?").matcher(str);
    List<Integer> digits = new ArrayList<Integer>();
    while (matcher.find())
      digits.add(Integer.valueOf(Integer.parseInt(matcher.group()))); 
    if (digits.size() >= 2) {
      int secondLastDigit = ((Integer)digits.get(digits.size() - 2)).intValue();
      return getDigitInUpperCase(secondLastDigit);
    } 
    return "";
  }
  
  private static String getDigitInUpperCase(int digit) {
    HashMap<Integer, String> digitMap = new HashMap<Integer, String>();
    digitMap.put(Integer.valueOf(0), "零");
    digitMap.put(Integer.valueOf(1), "一");
    digitMap.put(Integer.valueOf(2), "二");
    digitMap.put(Integer.valueOf(3), "三");
    digitMap.put(Integer.valueOf(4), "四");
    digitMap.put(Integer.valueOf(5), "五");
    digitMap.put(Integer.valueOf(6), "六");
    digitMap.put(Integer.valueOf(7), "七");
    digitMap.put(Integer.valueOf(8), "八");
    digitMap.put(Integer.valueOf(9), "九");
    return digitMap.get(Integer.valueOf(digit));
  }
  
  public void filterMap(List<SVGFile> svgFiles, String stName) {
    if (svgFiles.size() <= 1)
      return; 
    String stationName = cutFileName(stName);
    if (stationName.isEmpty())
      stationName = stName; 
    int maxSimilarity = -1;
    int strLength = 0;
    String maxSimilarityValue = "";
    Set<String> maxValueList = new HashSet<String>();
    for (SVGFile file : svgFiles) {
      String fileName = file.getFileName();
      int similarity = getSimilarity(stationName, fileName);
      if (similarity > maxSimilarity) {
        maxSimilarity = similarity;
        maxSimilarityValue = fileName;
        strLength = fileName.length();
        continue;
      } 
      if (similarity == maxSimilarity && fileName.length() < strLength) {
        maxSimilarityValue = fileName;
        continue;
      } 
      if (similarity == maxSimilarity && fileName.length() == strLength) {
        maxValueList.add(maxSimilarityValue);
        maxValueList.add(fileName);
        maxSimilarityValue = fileName;
      } 
    } 
    if (maxSimilarityValue.isEmpty())
      return; 
    for (Iterator<SVGFile> it = svgFiles.iterator(); it.hasNext(); ) {
      SVGFile svgFile = it.next();
      boolean shouldRemove = false;
      if (!maxValueList.isEmpty()) {
        for (String value : maxValueList) {
          if (svgFile.getFileName().equals(value)) {
            shouldRemove = false;
            break;
          } 
          shouldRemove = true;
        } 
      } else {
        shouldRemove = !svgFile.getFileName().equals(maxSimilarityValue);
      } 
      if (shouldRemove)
        it.remove(); 
    } 
  }
  
  public int getSimilarity(String s1, String s2) {
    int count = 0;
    for (int i = 0; i < s1.length(); i++) {
      if (s2.indexOf(s1.charAt(i)) != -1)
        count++; 
    } 
    return count;
  }
  
  public String cutFileName(String fileName) {
    fileName = fileName.replaceAll("([（(][^）)]*+[）)])", "");
    String regex = "[\\u4E00-\\u9FFF]";
    StringBuilder chinese = new StringBuilder();
    Pattern pattern = Pattern.compile(regex);
    Matcher matcher = pattern.matcher(fileName);
    while (matcher.find())
      chinese.append(matcher.group(0)); 
    return chinese.toString();
  }
  
  public String getDevNum(String word) {
    String powerDeviceName = word.trim();
    if (powerDeviceName.lastIndexOf(".") >= 0)
      powerDeviceName = powerDeviceName.substring(powerDeviceName.lastIndexOf(".") + 1); 
    String knifeName = "";
    String knifeCode = "";
    String equipTypeFlag = "";
    String equipTypeName = "";
    String[] type = { 
        SystemConstants.SwitchFlowGroundLine, SystemConstants.SwitchFlowGroundLine, 
        SystemConstants.SwitchSeparate, SystemConstants.SwitchSeparate, SystemConstants.SwitchSeparate, SystemConstants.SwitchSeparate, 
        SystemConstants.Switch, SystemConstants.Switch, SystemConstants.VolsbTransformer, 
        SystemConstants.VolsbTransformer, 
        SystemConstants.VolsbTransformer, SystemConstants.MotherLine, 
        SystemConstants.MotherLine, SystemConstants.InOutLine, SystemConstants.PowerTransformer, 
        SystemConstants.ElecShock, SystemConstants.ElecCapacity, SystemConstants.PowerTransformer };
    String[] key = { 
        "接地刀闸", "地刀", "隔离刀闸", "手车", "小车", "刀闸", "断路器", "开关", "PT", "pt", 
        "电压互感器", "母线", "母", 
        "线", "主变", "电抗器", "电容器", "#变" };
    for (int i = 0; i < key.length; i++) {
      if (word.lastIndexOf(key[i]) >= 0) {
        equipTypeFlag = type[i];
        equipTypeName = key[i];
        break;
      } 
    } 
    if (equipTypeFlag.equals(SystemConstants.InOutLine)) {
      if (powerDeviceName.toLowerCase().indexOf("kv") >= 0)
        powerDeviceName = powerDeviceName.substring(powerDeviceName.toLowerCase().indexOf("kv") + 2); 
      knifeCode = powerDeviceName.substring(0, powerDeviceName.indexOf("线") + 1).replace("将", "")
        .replace("退出", "").replace("启用", "").replace("投入", "").replace("检查", "").replace("kV", "");
      knifeCode = knifeCode.replaceAll("^\\d{3,5}", "").replaceAll("/", "").replaceAll("^\\d{3,5}", "");
      return knifeCode;
    } 
    powerDeviceName = StringUtils.killVoltInDevName(powerDeviceName);
    List<char[]> numList = (List)new ArrayList<char>();
    if (powerDeviceName.toUpperCase().lastIndexOf("KV") != -1) {
      knifeName = powerDeviceName.toUpperCase().substring(powerDeviceName.toUpperCase().lastIndexOf("KV") + 2);
    } else {
      knifeName = powerDeviceName;
    } 
    if (equipTypeFlag.equals(SystemConstants.VolsbTransformer)) {
      String[] num = { "Ⅰ", "Ⅱ", "Ⅲ", "Ⅳ", "Ⅴ", "Ⅵ" };
      for (int k = 0; k < num.length; k++) {
        if (knifeName.indexOf(num[k]) > -1) {
          knifeName = knifeName.replace(num[k], String.valueOf(k + 1));
          break;
        } 
      } 
    } 
    char[] charArr = knifeName.toCharArray();
    char[] keyArr = null;
    if (equipTypeFlag.equals(SystemConstants.Switch)) {
      keyArr = new char[] { 
          '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 
          '-', 'A', 'B', 'D', 'L', 'X', 'Y', 'Ⅰ', 
          'Ⅱ', 'Ⅲ', 
          'Ⅳ', 'Ⅴ', 'Ⅵ', '#', 'I', '旁' };
    } else if (equipTypeFlag.equals(SystemConstants.SwitchSeparate)) {
      keyArr = new char[] { 
          '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 
          '-', 'A', 'B', 'L', 'Ⅰ', 
          'Ⅱ', 'Ⅲ', 'Ⅳ', 'Ⅴ', 'Ⅵ', 
          '#', 'I', '旁' };
    } else if (equipTypeFlag.equals(SystemConstants.MotherLine)) {
      keyArr = new char[] { 
          '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 
          '-', 'A', 'B', 'M', 'Ⅰ', 
          'Ⅱ', 'Ⅲ', 'Ⅳ', 'Ⅴ', 'Ⅵ', 
          '#', 'I', '旁' };
    } else {
      keyArr = new char[] { 
          '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 
          '-', 'A', 'B', '甲', '乙', 'Ⅰ', 
          'Ⅱ', 'Ⅲ', 'Ⅳ', 'Ⅴ', 
          'Ⅵ', '#', 'I', '旁' };
    } 
    for (int j = charArr.length - 1; j >= 0; j--) {
      char ch = charArr[j];
      boolean isChInKey = false;
      for (int k = keyArr.length - 1; k >= 0; k--) {
        if (ch == keyArr[k]) {
          isChInKey = true;
          break;
        } 
      } 
      if (isChInKey)
        knifeCode = String.valueOf(ch) + knifeCode; 
      if (!isChInKey && !knifeCode.equals(""))
        break; 
    } 
    if (equipTypeFlag.equals(SystemConstants.PowerTransformer)) {
      if (knifeCode.indexOf("#") == -1)
        knifeCode = "#" + knifeCode; 
      knifeCode = "#" + knifeCode.replace("#", "");
    } else if (equipTypeFlag.equals(SystemConstants.MotherLine)) {
      if (knifeCode.indexOf("#") == -1)
        knifeCode = "#" + knifeCode; 
      knifeCode = "#" + knifeCode.replace("#", "");
      if (knifeCode.endsWith("M"))
        knifeCode = knifeCode.substring(0, knifeCode.length() - 1); 
    } else if (StringUtils.compareStr(equipTypeFlag, SystemConstants.ElecCapacity) == 0) {
      if (knifeCode.indexOf("#") == -1)
        knifeCode = "#" + knifeCode; 
      knifeCode = "#" + knifeCode.replace("#", "");
    } else if (StringUtils.compareStr(equipTypeFlag, SystemConstants.ElecShock) == 0) {
      if (knifeCode.indexOf("#") == -1)
        knifeCode = "#" + knifeCode; 
      knifeCode = "#" + knifeCode.replace("#", "");
    } else if (StringUtils.compareStr(equipTypeFlag, SystemConstants.EarthingTransformer) == 0) {
      if (knifeCode.indexOf("#") == -1)
        knifeCode = "#" + knifeCode; 
      knifeCode = "#" + knifeCode.replace("#", "");
    } 
    return knifeCode;
  }
  
  public List<RuleBaseMode> getRBMList(String word) {
    String station = "";
    for (Iterator<PowerDevice> it = CBSystemConstants.getMapPowerStation().values().iterator(); it.hasNext(); ) {
      PowerDevice st = it.next();
      String stName = CZPService.getCheckService().getDevName(st);
      if (stName.length() <= 1)
        continue; 
      if (word.contains(stName))
        station = stName; 
    } 
    if (station.equals("") && word.indexOf("站") >= 0)
      station = word.substring(0, word.indexOf("站") + 1); 
    if (station.equals("") && word.indexOf("变") >= 0)
      station = word.substring(0, word.indexOf("变") + 1); 
    return getRBMList(station, word);
  }
  
  public String getStationNameByCznr(String cznr) {
    String stationName = "";
    if (cznr.lastIndexOf("站") >= 0) {
      stationName = cznr.substring(0, cznr.lastIndexOf("站") + 1);
    } else if (cznr.lastIndexOf("变") >= 0) {
      stationName = cznr.substring(0, cznr.lastIndexOf("变") + 1);
    } else if (cznr.lastIndexOf("厂") >= 0) {
      stationName = cznr.substring(0, cznr.lastIndexOf("厂") + 1);
    } 
    if (stationName.indexOf("千伏") >= 0) {
      stationName = stationName.substring(stationName.lastIndexOf("千伏") + 2);
    } else if (stationName.toLowerCase().indexOf("kv") >= 0) {
      stationName = stationName.substring(stationName.toLowerCase().lastIndexOf("kv") + 2);
    } else if (stationName.toLowerCase().indexOf("切换至") >= 0 || stationName.toLowerCase().indexOf("切至") >= 0) {
      stationName = stationName.substring(stationName.toLowerCase().indexOf("至") + 1);
    } else if (stationName.toLowerCase().indexOf("切换到") >= 0 || stationName.toLowerCase().indexOf("切到") >= 0) {
      stationName = stationName.substring(stationName.toLowerCase().indexOf("到") + 1);
    } else if (stationName.toLowerCase().indexOf("断开") >= 0) {
      stationName = stationName.substring(stationName.toLowerCase().indexOf("断开") + 2);
    } else if (stationName.toLowerCase().indexOf("合上") >= 0) {
      stationName = stationName.substring(stationName.toLowerCase().indexOf("合上") + 2);
    } 
    return stationName;
  }
  
  public List<RuleBaseMode> getRBMList(String station, String word) {
    if ((station.contains("集控") || station.contains("调控")) && word != null) {
      Pattern pattern = Pattern.compile("([\\u4e00-\\u9fa5]+[站变])");
      Matcher matcher = pattern.matcher(word);
      if (matcher.find())
        station = matcher.group(1).replaceAll("合上|拉开|断开|检查", ""); 
    } 
    if (!TempTicketJX.isInversing)
      if (word.contains("检查") && word.contains("重合闸")) {
        if (!StringUtils.isEmpty(SafeCheckUtil.getStationByZl(word)))
          station = SafeCheckUtil.getStationByZl(word); 
        List<PowerDevice> lines = SafeCheckUtil.analysis(word, station);
        if (CollectionUtils.isEmpty(lines))
          return SafeCheckUtil.setLcmInfo(station, "302"); 
        boolean chztc = false;
        String sql = "select lien_id,line_name from " + CBSystemConstants.opcardUser + "T_A_LINE_RECLOSING_EXIT where lien_id='" + ((PowerDevice)lines.get(0)).getPowerDeviceID() + "'";
        List<Map<String, String>> sline = DBManager.query(sql);
        if (!CollectionUtils.isEmpty(sline))
          chztc = true; 
        if (!word.contains("重合闸已投入") && !chztc)
          return SafeCheckUtil.setLcmInfo(station, "317"); 
      } else if (word.contains("检查") && word.contains("保护") && !word.contains("开关间短引线保护")) {
        if (!StringUtils.isEmpty(SafeCheckUtil.getStationByZl(word)))
          station = SafeCheckUtil.getStationByZl(word); 
        if (!word.contains("全部保护已投入"))
          return SafeCheckUtil.setLcmInfo(station, "318"); 
        List<PowerDevice> lines = SafeCheckUtil.analysis(word, station);
        if (CollectionUtils.isEmpty(lines))
          return SafeCheckUtil.setLcmInfo(station, "302"); 
      }  
    if (SafeCheckUtil.filterList(word)) {
      List<RuleBaseMode> list = new ArrayList<RuleBaseMode>();
      RuleBaseMode rb = new RuleBaseMode();
      rb.setCheckout(Boolean.valueOf(true));
      list.add(rb);
      return list;
    } 
    if (word.contains("检查") && word.contains("确在"))
      word = word.replace("确在", "确为"); 
    if (word.contains("检查") && word.contains("确为")) {
      word = word.replace("，具备送电条件", "");
      if (word.contains("及线路") || word.contains("、")) {
        List<RuleBaseMode> list = new ArrayList<RuleBaseMode>();
        RuleBaseMode rb = new RuleBaseMode();
        rb.setCheckout(Boolean.valueOf(true));
        list.add(rb);
        return list;
      } 
    } 
    List<CardWordMode> wordRbmList = SafeCheckUtil.getCardWordModeList(station, word);
    String stationName = "";
    for (CardWordMode cwm : wordRbmList) {
      List<PowerDevice> devList = cwm.getPdList();
      for (PowerDevice dev : devList)
        stationName = dev.getPowerStationName(); 
    } 
    if (stationName.equals(""))
      stationName = station; 
    List<String> stationIDList = SafeCheckUtil.checkStationName(stationName);
    if (stationIDList.size() > 1) {
      System.out.println(String.valueOf(station) + "匹配到多个厂站:" + stationIDList.toString());
      return SafeCheckUtil.setLcmInfo(stationName, "309");
    } 
    if (CBSystemConstants.jh_tai == 1) {
      if (stationIDList.size() == 0)
        return SafeCheckUtil.setLcmInfo(stationName, "300"); 
      if (stationIDList.size() == 1 && CBSystemConstants.getStationPowerDevices(stationIDList.get(0)) == null)
        SafeCheckUtil.setLcmInfo(stationName, "308"); 
      if (wordRbmList.size() == 0) {
        SafeCheckUtil.setLcmInfo(stationName, "305");
      } else {
        for (CardWordMode cwm : wordRbmList) {
          if (cwm.getDeviceKind().equals("一次设备") && !cwm.getOperaTion().equals("核实")) {
            String beginstatus = cwm.getBeginStatus();
            String endstatus = cwm.getEndStatus();
            String beginstatusCheck = RuleExeUtil.getNumStatueNew(beginstatus);
            String endstatusCheck = RuleExeUtil.getNumStatueNew(endstatus);
            if (beginstatusCheck.equals("-1") || endstatusCheck.equals("-1"))
              return SafeCheckUtil.setLcmInfo(stationName, "305"); 
          } 
        } 
      } 
      for (CardWordMode cwm : wordRbmList) {
        List<RuleBaseMode> list = new ArrayList<RuleBaseMode>();
        if (cwm.getDeviceKind().equals("二次设备")) {
          RuleBaseMode rbm = new RuleBaseMode();
          list.add(rbm);
          return list;
        } 
        if (cwm.getOperaTion().equals("核实")) {
          RuleBaseMode rbm = new RuleBaseMode();
          list.add(rbm);
          return list;
        } 
      } 
    } 
    List<RuleBaseMode> rbmList = new ArrayList<RuleBaseMode>();
    if (stationIDList.size() == 1)
      rbmList = SafeCheckUtil.checkDeviceName(wordRbmList, stationIDList.get(0)); 
    if (CBSystemConstants.jh_tai == 1)
      for (RuleBaseMode rbm : rbmList) {
        if (!rbm.getPd().getPowerDeviceID().equals("") && 
          rbm.getPd().getPowerVoltGrade() != 500.0D && 
          !SafeCheckUtil.checkVoltName(word))
          return SafeCheckUtil.setLcmInfo(stationName, "306"); 
      }  
    if (rbmList.size() == 0) {
      RuleBaseMode rbm = new RuleBaseMode();
      PowerDevice dev = new PowerDevice();
      rbm.setPd(dev);
      rbmList.add(rbm);
    } 
    return rbmList;
  }
  
  public int SpecialCheck(PowerDevice pd, String word) {
    int rs = 0;
    if (pd == null) {
      if (word.indexOf("按现场") > -1 || word.indexOf("按照现场") > -1) {
        rs = 1;
      } else if (word.indexOf("按规定调整") > -1) {
        rs = 1;
      } else if (word.indexOf("中性点") > -1) {
        rs = 1;
      } else if (word.indexOf("相关") > -1) {
        rs = 1;
      } else if (word.indexOf("监控系统") > -1) {
        rs = 1;
      } else if (word.indexOf("倒至") > -1) {
        if (word.indexOf("由") > -1 && word.indexOf("开关") > -1 && word.indexOf("母线") > -1)
          rs = 1; 
      } else if (word.indexOf("三相电流基本平衡") > -1) {
        rs = 1;
      } else if (word.indexOf("转代") > -1) {
        rs = 1;
      } else if (word.indexOf("纵联保护") > -1) {
        rs = 1;
      } else if (word.indexOf("负荷的切换") > -1) {
        rs = 1;
      } else if (word.indexOf("拆除安措") > -1) {
        rs = 1;
      } else if (word.indexOf("挂") > -1) {
        if (word.indexOf("检修牌") > -1) {
          rs = 1;
        } else if (word.indexOf("传动牌") > -1) {
          rs = 1;
        } 
      } else if (word.indexOf("拆") > -1) {
        if (word.indexOf("检修牌") > -1) {
          rs = 1;
        } else if (word.indexOf("传动牌") > -1) {
          rs = 1;
        } 
      } else if (word.indexOf("测试") > -1) {
        rs = 1;
      } else if (word.indexOf("母差") > -1) {
        rs = 1;
      } 
    } else if (pd.getDeviceType().equals(SystemConstants.Switch) || pd.getDeviceType().equals(SystemConstants.SwitchSeparate) || pd.getDeviceType().equals(SystemConstants.SwitchFlowGroundLine)) {
      String devName = getDevName(pd);
      devName = devName.replace(getDevNum(devName), "");
      devName = StringUtils.killVoltInDevName(devName);
      devName = devName.replace("开关", "").replace("接地刀闸", "").replace("刀闸", "");
      if (!word.contains(devName)) {
        rs = 0;
      } else {
        rs = 1;
      } 
    } else {
      rs = 1;
    } 
    return rs;
  }
  
  public static Map<String, String> getUrlParams(String param) {
    Map<String, String> map = new HashMap<String, String>(0);
    if (param.equals(""))
      return map; 
    String[] params = param.split("&");
    for (int i = 0; i < params.length; i++) {
      String[] p = params[i].split("=");
      if (p.length == 2)
        map.put(p[0], p[1]); 
    } 
    return map;
  }
  
  public void initDeviceRunType(String stationID) {
    Map<String, ArrayList<String>> devicePointMap = (Map<String, ArrayList<String>>)SystemConstants.getMapToplogyDevicePoint().get(stationID);
    Map<String, ArrayList<String>> pointDeviceMap = (Map<String, ArrayList<String>>)SystemConstants.getMapToplogyPointDevice().get(stationID);
    List<PowerDevice> zxdList = new ArrayList<PowerDevice>();
    List<PowerDevice> zbList = new ArrayList<PowerDevice>();
    Map<String, PowerDevice> mapStationDevice = CBSystemConstants.getStationPowerDevices(stationID);
    if (mapStationDevice != null)
      for (Iterator<PowerDevice> iter = mapStationDevice.values().iterator(); iter.hasNext(); ) {
        PowerDevice device = iter.next();
        if (device.getDeviceType().equals(SystemConstants.SwitchFlowGroundLine) && device.getPowerDeviceName().contains("中性点")) {
          zxdList.add(device);
          continue;
        } 
        if (device.getDeviceType().equals(SystemConstants.PowerTransformer))
          zbList.add(device); 
      }  
    for (PowerDevice dev : zxdList) {
      dev.setDeviceRunType("neutralgroundknife");
      if (devicePointMap != null) {
        List<String> pointList = devicePointMap.get(dev.getPowerDeviceID());
        if (pointList != null && 
          pointList.size() == 1)
          for (PowerDevice zb : zbList) {
            if (dev.getPowerDeviceName().contains(zb.getPowerDeviceName())) {
              List<String> deviceList = pointDeviceMap.get(pointList.get(0));
              deviceList.add(zb.getPowerDeviceID());
              List<String> otherpointList = devicePointMap.get(zb.getPowerDeviceID());
              if (otherpointList != null)
                otherpointList.add(pointList.get(0)); 
            } 
          }  
      } 
    } 
  }
}
